<?php

/**
 * Ajax Controller
 *
 * @link 		https://entusiastics.com
 * @since 		1.0.0
 *
 * @package 	Entusiastics_Quiz_Game
 * @subpackage 	Entusiastics_Quiz_Game/admin/controllers
 */

if( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly

// handle all ajax

function entusiastics_quiz_game_ajax() {

	$action = empty($_POST['entusiastic_game_quiz_action']) ? 'start' : $_POST['entusiastic_game_quiz_action'];
	
	switch($action) {
		// answer a question or quiz
		case 'answer':
		echo QuizzesController :: answer_question();
		break;
		case 'start':
		default:
		echo QuizzesController :: start_quiz();
		break;
	}

	exit;
}

function entusiastics_move_questions_ajax() {

	$action = empty($_POST['action']) ? 'move' : $_POST['action'];
	
	switch($action) {
		// move question
		case 'move':
		default:
		echo QuestionsController :: move($_POST);
		break;
	}

	exit;
}

function entusiastics_get_questions_with_choices() {

	$action = empty($_POST['action']) ? 'questions' : $_POST['action'];
	
	switch($action) {
		// move question
		case 'questions':
		default:
		echo QuestionsController :: getQuestions($_POST);
		break;
	}

	exit;
}


function entusiastics_add_choice_ajax() {
	ob_start();
	include(ENTUSIASTICS_QUIZ_GAME_PLUGIN_PATH."admin/partials/entusiastics-quiz-game-choice.php");
	$content = ob_get_clean();	
	$content = str_replace("\n", '', $content);
	echo $content;
	exit;
}


function entusiastics_finalize_quizz() {

	$action = empty($_POST['entusiastics_finalize_quizz']) ? 'finalize' : $_POST['entusiastics_finalize_quizz'];

	$_quiz = new Quiz();
	$quiz = $_quiz->getQuizById($_POST['quiz_id']);
	$last_profile = $_POST['last_profile'];
	$last_question = $_POST['last_question'];
	$last_connotation = $_POST['last_connotation'];
	$session_id = $_POST['session_id'];
	
	switch($action) {
		// finalize quizz
		case 'finalize':
		default:
		echo QuizzesController :: finalize($quiz, $last_profile, $last_question, $last_connotation, $session_id);
		break;
	}

	exit;
}