<?php

/**
 * Provide a admin area view for the plugin
 *
 * This file is used to markup the admin-facing aspects of the plugin.
 *
 * @link       https://entusiastics.com
 * @since      1.0.0
 *
 * @package    Entusiastics_Quiz_Game
 * @subpackage Entusiastics_Quiz_Game/admin/partials
 */


?>

<div class="wrap">

	<h1 class="wp-heading-inline">
		<?php 
		$frase = __('Admnistrar preguntas en', 'entusiastics-quiz-game');
		echo $frase.'<strong> '.@$quiz->title.'</strong>'
		?>
	</h1>

	<ul class="header-links-list">
		<li >
			<a href="admin.php?page=entusiastics-quiz-game-quizzes-list">
				<?php _e('Volver al listado de los Quizzes', 'entusiastics-quiz-game')?>
			</a>
		</li>
		<span>|</span>
		<li>
			<a href="admin.php?page=entusiastics-quiz-game-quizz&action=edit&id=<?php echo $quiz->id?>">
				<?php
				$frase = __('Editar el Quiz', 'entusiastics-quiz-game');
				echo $frase.'<strong> '.@$quiz->title.'</strong>'
				?>
			</a>
		</li>
	</ul>

	<hr class="wp-header-end">
	
	<div class="postbox-container" style="width: 100%;">

		<div class="notice drag-info-text" style="display: none;">
			<p>
				<?php _e('Arrastrar y soltar en la posicion deseada la pregunta.Una vez ordenadas las preguntas pulsa sobre el botón <strong>"Guardar Nuevo Orden"</strong> para guardar el nuevo orden.', 'entusiastics-quiz-game')?>
			</p>
		</div>

		<div id="success-sorted-notice" class="notice notice-success is-dismissible" style="display: none;">
			<p>
				<?php _e('Preguntas ordenadas con éxito', 'entusiastics-quiz-game')?>
			</p>
		</div>

		<div id="error-sorted-notice" class="notice notice-error is-dismissible" style="display: none;">
			<p>
				<?php _e('Ha habido un error al ordenar las preguntas.', 'entusiastics-quiz-game')?>
			</p>
		</div>

		<?php if(!empty($questions)):?>

			<table class="widefat">

				<tr>
					<th><?php _e('Orden', 'entusiastics-quiz-game')?></th>
					<th><?php _e('Pregunta', 'entusiastics-quiz-game')?></th>
					<th><?php _e('Tipo', 'entusiastics-quiz-game')?></th>
					<th><?php _e('Editar / Borrar', 'entusiastics-quiz-game')?></th>
				</tr>

				<tbody id="sortable">

					<?php foreach($questions as $cnt=>$question):

						$class = ('alternate' == @$class) ? '' : 'alternate';?>

						<tr class="<?php echo $class?>">

							<td class="sort-order"><?php echo $question->sort_order?></td>
							<input type="hidden" class="question-id" data-question="<?php echo $question->id?>">
							<td><?php echo stripslashes($question->question)?></td>
							<td><?php echo $question->qtype?></td>
							<td>
								<a href="admin.php?page=entusiastics-quiz-game-questions&action=edit&id=<?php echo $question->id?>">
									<?php _e('Editar', 'entusiastics-quiz-game')?>
								</a> 
								<span>|</span> 
								<a href="#" onclick="entusiasticsQuizGameConfirmDelete(<?php echo $question->id?>);return false;">
									<?php _e('Borrar', 'entusiastics-quiz-game')?>
								</a>		
							</td>

						</tr>

					<?php endforeach;?>	

				</tbody>

			</table>

			<?php else:?>
				<div class="notice">
					<p><?php _e('Aún no has introducido ninguna pregunta en el Quizz.') ?></p>
				</div>
			<?php endif;?>

			<div style="margin-top: 25px;">
				<a href="admin.php?page=entusiastics-quiz-game-questions&action=add&quiz_id=<?php echo $quiz->id?>" class="button-primary" id="new-question-button">
					<?php _e('Añadir Nueva Pregunta', 'entusiastics-quiz-game')?>
				</a>

				<button type="button" id="active-sortable" class="button-primary button-sortable">
					<?php _e('Ordenar Preguntas', 'entusiastics-quiz-game')?>
				</button>
				<input type="hidden" id="sortable-button-text" value="<?php _e('Guardar Nuevo Orden', 'entusiastics-quiz-game')?>">

			</div>

		</div>
	</div>

	<script type="text/javascript" >

		function entusiasticsQuizGameConfirmDelete(qid) {

			if(confirm("<?php _e('Estas seguro?', 'entusiastics-quiz-game')?>")) {
				window.location = 'admin.php?page=entusiastics-quiz-game-questions&quiz_id=<?php echo $quiz->id?>&del=1&id='+qid;
			}

		}

		jQuery('#active-sortable').on('click',function(){

			jQuery(this).toggleClass('active');

			if(!jQuery(this).hasClass('active')) {

				var old_text = jQuery('#sortable-button-text').val();
				var new_text = jQuery('#active-sortable').text();

				jQuery( "#sortable" ).sortable('disable');
				jQuery( "#draggable" ).sortable('disable');

				jQuery('#sortable-button-text').val(new_text);
				jQuery('#active-sortable').text(old_text);

				jQuery('.drag-info-text').fadeOut();

				jQuery('#new-question-button').css('display', 'inline-block');

				jQuery('#sortable').removeClass('active');

				var sorted_list = [];

				jQuery( ".sort-order" ).each(function(key, item) {

					var question = {id:'',sort_order: ''};

					question.sort_order = jQuery(item).text();
					question.id = jQuery(item).next('.question-id').data('question');

					sorted_list[key] = question;

				});

				jQuery.ajax({
					data: {
						sorted_list : sorted_list,
						quiz_id : '<?php echo $quiz->id?>'
					},
					type: 'POST',
					url: 'admin-ajax.php?action=entusiastics_move_questions_ajax&entusiastics_move_questions=move',
					success: function(response) {

						if(response == 1) {
							jQuery('#success-sorted-notice').fadeIn();
						} else {
							jQuery('#error-sorted-notice').fadeIn();
						}

					}
				});

			} else{

				jQuery('#new-question-button').css('display', 'none');

				jQuery('.drag-info-text').fadeIn();

				var old_text = jQuery('#active-sortable').text();
				var new_text = jQuery('#sortable-button-text').val();

				jQuery('#sortable-button-text').val(old_text);
				jQuery('#active-sortable').text(new_text);

				jQuery('#sortable').addClass('active');
				jQuery( "#sortable" ).sortable({ revert: true, update: function(event, ui) {

					jQuery( ".sort-order" ).each(function(key, item) {
						var sort_order = key + 1;
						jQuery(this).text(sort_order + '');
					});

				}});

				jQuery( "#draggable" ).draggable({
					connectToSortable: "#sortable",
					helper: "clone",
					opacity: 0.7,
					revert: "invalid"
				});

				jQuery('#sortable').sortable('enable');
				jQuery( "#draggable" ).draggable('enable');

				jQuery( "tr" ).disableSelection();
				jQuery( "td" ).disableSelection();
			}	
		});
	</script>