<?php

/**
 * Fired during plugin instalation
 *
 * @link 		https://entusiastics.com
 * @since 		1.0.0
 *
 * @package 	Entusiastics_Quiz_Game
 * @subpackage 	Entusiastics_Quiz_Game/includes
 */

class Entusiastics_Quiz_Game_Database {

	static function install($version, $update = false) {

		global $wpdb;	
		$wpdb->show_errors();

		// define table names 
		define( 'ENTUSIASTICS_QUIZ_GAME_QUIZZES', $wpdb->prefix. "entusiastics_quiz_game_quizzes");
		define( 'ENTUSIASTICS_QUIZ_GAME_QUESTIONS', $wpdb->prefix. "entusiastics_quiz_game_questions");
		define( 'ENTUSIASTICS_QUIZ_GAME_CHOICES', $wpdb->prefix. "entusiastics_quiz_game_choices");
		define( 'ENTUSIASTICS_QUIZ_GAME_RESULTS', $wpdb->prefix. "entusiastics_quiz_game_results");
		define( 'ENTUSIASTICS_QUIZ_GAME_COMPLETED', $wpdb->prefix. "entusiastics_quiz_game_completed");
		define( 'ENTUSIASTICS_QUIZ_GAME_USER_ANSWERS', $wpdb->prefix. "entusiastics_quiz_game_user_answers");
		define( 'ENTUSIASTICS_QUIZ_GAME_TYPES', $wpdb->prefix. "entusiastics_quiz_game_types");
		define( 'ENTUSIASTICS_QUIZ_GAME_CATEGORIES', $wpdb->prefix. "entusiastics_quiz_game_categories");
		define( 'ENTUSIASTICS_QUIZ_GAME_PROFILES', $wpdb->prefix. "entusiastics_quiz_game_profiles");
		define( 'ENTUSIASTICS_QUIZ_GAME_OBJECTIVES', $wpdb->prefix. "entusiastics_quiz_game_objectives");
		
		// define plugin version
		define( 'ENTUSIASTICS_QUIZ_GAME_VERSION', $version);

	   	// quizzes
		if($wpdb->get_var("SHOW TABLES LIKE '".ENTUSIASTICS_QUIZ_GAME_QUIZZES."'") != ENTUSIASTICS_QUIZ_GAME_QUIZZES) {        
			$sql = "CREATE TABLE `" . ENTUSIASTICS_QUIZ_GAME_QUIZZES . "` (
			`id` INT UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY,
			`publish_state` INT UNSIGNED NULL DEFAULT 0,	
			`title` VARCHAR(255) NOT NULL DEFAULT '',
			`intro_text` VARCHAR(255) NULL DEFAULT '',
			`description_text` VARCHAR(255) NULL DEFAULT '',
			`category_id` INT UNSIGNED NOT NULL DEFAULT 0,	
			`duration` TIME NULL,
			`image_url` VARCHAR(255) NOT NULL DEFAULT '',
			`image_id` INT UNSIGNED NULL DEFAULT 0,
			`thumbnail_summary` VARCHAR(255) NOT NULL DEFAULT '',
			`times_to_take` INT UNSIGNED NULL DEFAULT 0,
			`theme_color` VARCHAR(255) NULL DEFAULT '#d3d3d3',
			`comments` INT UNSIGNED NOT NULL DEFAULT 0,
			`created_at` DATETIME NOT NULL DEFAULT CURRENT_TIMESTAMP,
			`updated_at` DATETIME NULL
		) DEFAULT CHARSET=utf8mb4;";

		$wpdb->query($sql);
	}

		// questions
	if($wpdb->get_var("SHOW TABLES LIKE '".ENTUSIASTICS_QUIZ_GAME_QUESTIONS."'") != ENTUSIASTICS_QUIZ_GAME_QUESTIONS) {        
		$sql = "CREATE TABLE `" . ENTUSIASTICS_QUIZ_GAME_QUESTIONS . "` (
		`id` INT UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY,
		`quiz_id` INT UNSIGNED NOT NULL DEFAULT 0,
		`question` VARCHAR(255) NOT NULL DEFAULT '',
		`question_aclaration` TEXT,
		`qtype` VARCHAR(20) NOT NULL DEFAULT '',
		`rango` INT UNSIGNED NOT NULL DEFAULT 0,
		`autocontinue` TINYINT UNSIGNED NOT NULL DEFAULT 0,
		`sort_order` INT UNSIGNED NOT NULL DEFAULT 0,
		`video_url` VARCHAR(255) NOT NULL DEFAULT '',
		`video_id` INT UNSIGNED NOT NULL DEFAULT 0,
		`video_type` VARCHAR(255) NOT NULL DEFAULT '',
		`video_ends` VARCHAR(255) NOT NULL DEFAULT '',
		`image_url` VARCHAR(255) NOT NULL DEFAULT '',
		`image_id` INT UNSIGNED NULL DEFAULT 0,
		`symbol` VARCHAR(255) NULL DEFAULT 'letters'   
	) DEFAULT CHARSET=utf8mb4;";

	$wpdb->query($sql);
} 

	  // choices
if($wpdb->get_var("SHOW TABLES LIKE '".ENTUSIASTICS_QUIZ_GAME_CHOICES."'") != ENTUSIASTICS_QUIZ_GAME_CHOICES) {        
	$sql = "CREATE TABLE `" . ENTUSIASTICS_QUIZ_GAME_CHOICES . "` (
	`id` INT UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY,
	`quiz_id` INT UNSIGNED NOT NULL DEFAULT 0,
	`question_id` INT UNSIGNED NOT NULL DEFAULT 0,
	`choice` TEXT,
	`goto` VARCHAR(100) NOT NULL DEFAULT 'next',
	`profile_id` INT UNSIGNED NOT NULL DEFAULT 0,
	`video_url` VARCHAR(255) NOT NULL DEFAULT '',
	`video_id` INT UNSIGNED NOT NULL DEFAULT 0,
	`video_type` VARCHAR(255) NOT NULL DEFAULT ''
) DEFAULT CHARSET=utf8mb4;";

$wpdb->query($sql);

} 

	  // results
if($wpdb->get_var("SHOW TABLES LIKE '".ENTUSIASTICS_QUIZ_GAME_RESULTS."'") != ENTUSIASTICS_QUIZ_GAME_RESULTS) {        
	$sql = "CREATE TABLE `" . ENTUSIASTICS_QUIZ_GAME_RESULTS . "` (
	`id` INT UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY,
	`quiz_id` INT UNSIGNED NOT NULL DEFAULT 0,
	`title` VARCHAR(255) NOT NULL DEFAULT '',
	`description` TEXT,
	`redirect_url` VARCHAR(255) NOT NULL DEFAULT '',
	`created_at` DATETIME NOT NULL DEFAULT CURRENT_TIMESTAMP,
	`updated_at` DATETIME NULL
) DEFAULT CHARSET=utf8mb4;";

$wpdb->query($sql);
} 

	  // completed quizzes	
if($wpdb->get_var("SHOW TABLES LIKE '".ENTUSIASTICS_QUIZ_GAME_COMPLETED."'") != ENTUSIASTICS_QUIZ_GAME_COMPLETED) {        
	$sql = "CREATE TABLE `" . ENTUSIASTICS_QUIZ_GAME_COMPLETED . "` (
	`id` INT UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY,
	`quiz_id` INT UNSIGNED NOT NULL DEFAULT 0,
	`result_id` INT UNSIGNED NOT NULL DEFAULT 0,
	`created_at` DATETIME,
	`ip` VARCHAR(30) NOT NULL DEFAULT '',
	`user_id` INT UNSIGNED NOT NULL DEFAULT 0,
	`snapshot` TEXT,
	`not_empty` TINYINT NOT NULL DEFAULT 0,
	`source_url` VARCHAR(255) NOT NULL DEFAULT ''
) DEFAULT CHARSET=utf8mb4;";

$wpdb->query($sql);
}

	  // details of user answers
if($wpdb->get_var("SHOW TABLES LIKE '".ENTUSIASTICS_QUIZ_GAME_USER_ANSWERS."'") != ENTUSIASTICS_QUIZ_GAME_USER_ANSWERS) {        
	$sql = "CREATE TABLE `" . ENTUSIASTICS_QUIZ_GAME_USER_ANSWERS . "` (
	`id` INT UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY,
	`quiz_id` INT UNSIGNED NOT NULL DEFAULT 0,
	`completion_id` INT UNSIGNED NOT NULL DEFAULT 0,
	`question_id` INT UNSIGNED NOT NULL DEFAULT 0,
	`profile_id` INT UNSIGNED NOT NULL DEFAULT 0,
	`answer` TEXT,
	`comments` TEXT				  
) DEFAULT CHARSET=utf8mb4;";

$wpdb->query($sql);
}

if($wpdb->get_var("SHOW TABLES LIKE '".ENTUSIASTICS_QUIZ_GAME_CATEGORIES."'") != ENTUSIASTICS_QUIZ_GAME_CATEGORIES) { 
	$sql = "CREATE TABLE `" . ENTUSIASTICS_QUIZ_GAME_CATEGORIES . "` (
	`id` INT UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY,
	`name` VARCHAR(30) NOT NULL DEFAULT '',
	`category_description` TEXT,
	`created_at` DATETIME NOT NULL DEFAULT CURRENT_TIMESTAMP,
	`updated_at` DATETIME NULL	  
) DEFAULT CHARSET=utf8mb4;";

$wpdb->query($sql);
}

if($wpdb->get_var("SHOW TABLES LIKE '".ENTUSIASTICS_QUIZ_GAME_CATEGORIES."'") == ENTUSIASTICS_QUIZ_GAME_CATEGORIES) {

	// select the category
	$category = $wpdb->get_row($wpdb->prepare("SELECT * FROM ".ENTUSIASTICS_QUIZ_GAME_CATEGORIES." WHERE id=%d", 1));

	if(empty($category)) {

		$sql = "INSERT INTO ".ENTUSIASTICS_QUIZ_GAME_CATEGORIES." SET name='Sin Categorizar', category_description='Categoría por defecto'";

		$wpdb->query($sql);
	}
}

if($wpdb->get_var("SHOW TABLES LIKE '".ENTUSIASTICS_QUIZ_GAME_PROFILES."'") != ENTUSIASTICS_QUIZ_GAME_PROFILES) { 
	$sql = "CREATE TABLE `" . ENTUSIASTICS_QUIZ_GAME_PROFILES . "` (
	`id` INT UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY,
	`name` VARCHAR(30) NOT NULL DEFAULT '',
	`connotation` TINYINT UNSIGNED NOT NULL DEFAULT 0,
	`profile_description` TEXT,
	`image_url` VARCHAR(255) NOT NULL DEFAULT '',
	`image_id` VARCHAR(255) NOT NULL DEFAULT '',
	`created_at` DATETIME NOT NULL DEFAULT CURRENT_TIMESTAMP,
	`updated_at` DATETIME NULL		  
) DEFAULT CHARSET=utf8mb4;";

$wpdb->query($sql);
}

if($wpdb->get_var("SHOW TABLES LIKE '".ENTUSIASTICS_QUIZ_GAME_PROFILES."'") == ENTUSIASTICS_QUIZ_GAME_PROFILES) {

	// select the profile
	$profile = $wpdb->get_row($wpdb->prepare("SELECT * FROM ".ENTUSIASTICS_QUIZ_GAME_PROFILES." WHERE id=%d", 1));

	if(empty($profile)) {

		$sql = "INSERT INTO ".ENTUSIASTICS_QUIZ_GAME_PROFILES." SET name='Sin Perfil', connotation=3, profile_description='Categoría por defecto', image_url='', image_id=''";

		$wpdb->query($sql);
	}
}

if($wpdb->get_var("SHOW TABLES LIKE '".ENTUSIASTICS_QUIZ_GAME_OBJECTIVES."'") != ENTUSIASTICS_QUIZ_GAME_OBJECTIVES) { 
	$sql = "CREATE TABLE `" . ENTUSIASTICS_QUIZ_GAME_OBJECTIVES . "` (
	`id` INT UNSIGNED NOT NULL AUTO_INCREMENT PRIMARY KEY,
	`name` VARCHAR(255) NOT NULL DEFAULT '',
	`description` TEXT,
	`quiz_id` INT UNSIGNED NOT NULL DEFAULT 0	  
) DEFAULT CHARSET=utf8mb4;";

$wpdb->query($sql);
}

	  // fix sort order once for old quizzes (in version 0.7.5)
if(get_option('entusiastics_quiz_game_fixed_sort_order') != 1) {
	Question::fix_sort_order_global();
	update_option('entusiastics_quiz_game_fixed_sort_order', 1);
}	

update_option('entusiastics_quiz_game_version', ENTUSIASTICS_QUIZ_GAME_VERSION);

}

}
